
namespace demo_A_ctor {
    std::array<int,18> const data_0 {
        -1, -1, -1, -1,
         5, 4, 3, 2, 1, 0, 11, 10, 9, 8, 7, 6,
        -1, -1};

    std::array<int,18> const data_1 {
        -1, -1, -1, -1,
         6, 5, 4, 3, 2, 1, 12, 11, 10, 9, 8, 7,
        -1, -1
    };

    std::vector<int> const part_0 {10, 8, 5, 2};
    std::vector<int> const part_1 {11, 9, 6, 3};

    #if USE_ARR_0
        void arr_0 () {
            cout << "\n\n ----- demo_A_ctor::arr_0 -----";
            cout << "\n " << std::boolalpha;
            permu_arr_0<8> const a;
            cout << "\n a: " << a << " derangement? " << a.is_deranged();
            permu_arr_0<9> const b (false);
            cout << "\n b: " << b << " derangement? " << b.is_deranged();
            permu_arr_0<10> const c (true);
            cout << "\n c: " << c << " derangement? " << c.is_deranged();
            permu_arr_0<6> const d {0, 3, 2, 5, 4, 1};
            cout << "\n d: " << d << " derangement? " << d.is_deranged();
            permu_arr_0<12> const e {data_0.begin() + 4, data_0.end() - 2};
            cout << "\n e: " << e << " derangement? " << e.is_deranged();
            std::array<int,9> const t {2, 6, 1, 5, 0, 4, 8, 3, 7};
            permu_arr_0<9> const f {t};
            cout << "\n f: " << f << " derangement? " << f.is_deranged();

            cout << "\n\n partials using {10, 8, 5, 2}: ";
            using pa0 = permu_arr_0<13>;
            pa0 const g (pa0::partial ({10, 8, 5, 2}));
            cout << "\n g:   " << g;
            pa0 const h (pa0::partial (part_0.begin(), part_0.end()));
            cout << "\n h:   " << h;
            cout << std::noboolalpha;
        }
    #endif

    #if USE_ARR_1
        void arr_1 () {
            cout << "\n\n ----- demo_A_ctor::arr_1 -----";
            cout << "\n " << std::boolalpha;
            permu_arr_1<8> const a;
            cout << "\n a: " << a << " derangement? " << a.is_deranged();
            permu_arr_1<9> const b (false);
            cout << "\n b: " << b << " derangement? " << b.is_deranged();
            permu_arr_1<10> const c (true);
            cout << "\n c: " << c << " derangement? " << c.is_deranged();
            permu_arr_1<6> const d {1, 4, 3, 6, 5, 2};
            cout << "\n d: " << d << " derangement? " << d.is_deranged();
            permu_arr_1<12> const e {data_1.begin() + 4, data_1.end() - 2};
            cout << "\n e: " << e << " derangement? " << e.is_deranged();
            std::array<int,9> const t {3, 7, 2, 6, 1, 5, 9, 4, 8};
            permu_arr_1<9> const f {t};
            cout << "\n f: " << f << " derangement? " << f.is_deranged();
            cout << std::noboolalpha;

            cout << "\n\n partials using {11, 9, 6, 3}: ";
            using pa1 = permu_arr_1<13>;
            pa1 const g (pa1::partial ({11, 9, 6, 3}));
            cout << "\n g:   " << g;
            pa1 const h (pa1::partial (part_1.begin(), part_1.end()));
            cout << "\n h:   " << h;
            cout << std::noboolalpha;
        }
    #endif

    #if USE_VEC_0
        void vec_0 () {
            cout << "\n\n ----- demo_A_ctor::vec_0 -----";
            cout << "\n " << std::boolalpha;
            permu_vec_0 const a (8);
            cout << "\n a: " << a << " derangement? " << a.is_deranged();
            permu_vec_0 const b (9, false);
            cout << "\n b: " << b << " derangement? " << b.is_deranged();
            permu_vec_0 const c (10, true);
            cout << "\n c: " << c << " derangement? " << c.is_deranged();
            permu_vec_0 const d {0, 3, 2, 5, 4, 1};
            cout << "\n d: " << d << " derangement? " << d.is_deranged();
            permu_vec_0 const e {data_0.begin() + 4, data_0.end() - 2};
            cout << "\n e: " << e << " derangement? " << e.is_deranged();
            std::vector<int> const t {2, 6, 1, 5, 0, 4, 8, 3, 7};
            permu_vec_0 const f {t};
            cout << "\n f: " << f << " derangement? " << f.is_deranged();
            cout << std::noboolalpha;

            cout << "\n\n partials using {10, 8, 5, 2}: ";
            using pv0 = permu_vec_0;
            pv0 const g (pv0::partial (13, {10, 8, 5, 2}));
            cout << "\n g:   " << g;
            pv0 const h (pv0::partial (13, part_0.begin(), part_0.end()));
            cout << "\n h:   " << h;
            cout << std::noboolalpha;
        }
    #endif

    #if USE_VEC_1
        void vec_1 () {
            cout << "\n\n ----- demo_A_ctor::vec_1 -----";
            cout << "\n " << std::boolalpha;
            permu_vec_1 const a (8);
            cout << "\n a: " << a << " derangement? " << a.is_deranged();
            permu_vec_1 const b (9, false);
            cout << "\n b: " << b << " derangement? " << b.is_deranged();
            permu_vec_1 const c (10, true);
            cout << "\n c: " << c << " derangement? " << c.is_deranged();
            permu_vec_1 const d {1, 4, 3, 6, 5, 2};
            cout << "\n d: " << d << " derangement? " << d.is_deranged();
            permu_vec_1 const e {data_1.begin() + 4, data_1.end() - 2};
            cout << "\n e: " << e << " derangement? " << e.is_deranged();
            std::vector<int> const t {3, 7, 2, 6, 1, 5, 9, 4, 8};
            permu_vec_1 const f {t};
            cout << "\n f: " << f << " derangement? " << f.is_deranged();
            cout << std::noboolalpha;

            cout << "\n\n partials using {11, 9, 6, 3}: ";
            using pv1 = permu_vec_1;
            pv1 const g (pv1::partial (13, {11, 9, 6, 3}));
            cout << "\n g:   " << g;
            pv1 const h (pv1::partial (13, part_1.begin(), part_1.end()));
            cout << "\n h:   " << h;
            cout << std::noboolalpha;
        }
    #endif
}