
namespace demo_E_laminate {

    constexpr int s {5};
    constexpr int t {4};

    #if USE_ARR_0
        void arr_0 () {
            cout << "\n\n ----- demo_E_laminate::arr_0 -----";
            permu_arr_0<s> const a {3, 4, 2, 0, 1};
            permu_arr_0<t> const b {1, 2, 0, 3};

            permu_arr_0<s*t> const c {a.laminate(b)};
            cout << "\n a: " << a;
            cout << "\n b: " << b;
            cout << "\n c: " << c;
            permu_arr_0<b.size()*a.size()> const d {b.laminate(a)};
            cout << "\n d: " << d;
        }
    #endif

    #if USE_ARR_1
        void arr_1 () {
            cout << "\n\n ----- demo_E_laminate::arr_1 -----";
            permu_arr_1<s> const a {4, 5, 3, 1, 2};
            permu_arr_1<t> const b {2, 3, 1, 4};

            permu_arr_1<s*t> const c {a.laminate(b)};
            cout << "\n a: " << a;
            cout << "\n b: " << b;
            cout << "\n c: " << c;
            permu_arr_1<t*s> const d {b.laminate(a)};
            cout << "\n d: " << d;
        }
    #endif

    #if USE_VEC_0
        void vec_0 () {
            cout << "\n\n ----- demo_E_laminate::vec_0 -----";
            permu_vec_0 const a {3, 4, 2, 0, 1};
            permu_vec_0 const b {1, 2, 0, 3};

            permu_vec_0 const c {a.laminate(b)};
            cout << "\n a: " << a;
            cout << "\n b: " << b;
            cout << "\n c: " << c;
            permu_vec_0 const d {b.laminate(a)};
            cout << "\n d: " << d;
        }
    #endif

    #if USE_VEC_1
        void vec_1 () {
            cout << "\n\n ----- demo_E_laminate::vec_1 -----";
            permu_vec_1 const a {4, 5, 3, 1, 2};
            permu_vec_1 const b {2, 3, 1, 4};

            permu_vec_1 const c {a.laminate(b)};
            cout << "\n a: " << a;
            cout << "\n b: " << b;
            cout << "\n c: " << c;
            permu_vec_1 const d {b.laminate(a)};
            cout << "\n d: " << d;
        }
    #endif

    #if USE_ARR_0
        void breakdown () {
            cout << "\n\n ----- demo_E_laminate::breakdown -----";
            permu_arr_0<s> const a {3, 4, 2, 0, 1};
            permu_arr_0<t> const b {1, 2, 0, 3};

            permu_arr_0<s*t> c {a.laminate(b)};
            cout << "\n a: " << a;
            cout << "\n b: " << b;
            cout << "\n c: " << c;

            cout << "\n ";
            permu_arr_0<10> d {a.direct_sum<5> (a)};
            cout << "\n d: " << d << " a.direct_sum (a)";

            permu_arr_0<15> e {d.skew_sum (a)};
            cout << "\n e: " << e << " d.skew_sum (a)";

            permu_arr_0<20> f {e.direct_sum (a)};
            cout << "\n f: " << f << " e.direct_sum (a)";
        }
    #endif
}