
namespace demo_J_shuffle {
    constexpr int p { 7};
    constexpr int q { 5};

    void show_pq (int const p, int const q) {
        cout << "(" << setw (2) << p;
        cout << ", " << setw (2) << q << ")";
    }

    #if USE_ARR_0
        void arr_0 () {
            cout << "\n\n ----- demo_J_shuffle::arr_0 -----";
            cout << "\n\n positions:               " << permu_arr_0<demo_ord> (false);
            auto w (demo_wa);

            cout << "\n\n start:                   " << w;
            w.shuffle (false, p, q);
            cout << "\n out_shuffle: ";
            show_pq (p, q);
            cout << ":   " << w;
            w.unshuffle (false, p, q);
            cout << "\n out_unshuffle: ";
            show_pq (p, q);
            cout << ": " << w;

            cout << "\n\n start:                   " << w;
            w.shuffle (true, p, q);
            cout << "\n in_shuffle: ";
            show_pq (p, q);
            cout << ":    " << w;
            w.unshuffle (true, p, q);
            cout << "\n in_unshuffle: ";
            show_pq (p, q);
            cout << ":  " << w;
        }
    #endif

    #if USE_ARR_1
        void arr_1 () {
            cout << "\n\n ----- demo_J_shuffle::arr_1 -----";
            cout << "\n\n positions:               " << permu_arr_1<demo_ord> (false);
            auto x (demo_xa);

            cout << "\n\n start:                   " << x;
            x.shuffle (false, p + 1, q + 1);
            cout << "\n out_shuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":   " << x;
            x.unshuffle (false, p + 1, q + 1);
            cout << "\n out_unshuffle: ";
            show_pq (p + 1, q + 1);
            cout << ": " << x;

            cout << "\n\n start:                   " << x;
            x.shuffle (true, p + 1, q + 1);
            cout << "\n in_shuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":    " << x;
            x.unshuffle (true, p + 1, q + 1);
            cout << "\n in_unshuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":  " << x;
        }
    #endif

    #if USE_VEC_0
        void vec_0 () {
            cout << "\n\n ----- demo_J_shuffle::vec_0 -----";
            cout << "\n\n positions:               " << permu_vec_0 (demo_ord, false);
            auto y (demo_ya);

            cout << "\n\n start:                   " << y;
            y.shuffle (false, p, q);
            cout << "\n out_shuffle: ";
            show_pq (p, q);
            cout << ":   " << y;
            y.unshuffle (false, p, q);
            cout << "\n out_unshuffle: ";
            show_pq (p, q);
            cout << ": " << y;

            cout << "\n\n start:                   " << y;
            y.shuffle (true, p, q);
            cout << "\n in_shuffle: ";
            show_pq (p, q);
            cout << ":    " << y;
            y.unshuffle (true, p, q);
            cout << "\n in_unshuffle: ";
            show_pq (p, q);
            cout << ":  " << y;
        }
    #endif

    #if USE_VEC_1
        void vec_1 () {
            cout << "\n\n ----- demo_J_shuffle::vec_1 -----";
            cout << "\n\n positions:               " << permu_vec_1 (demo_ord, false);
            auto z (demo_za);

            cout << "\n\n start:                   " << z;
            z.shuffle (false, p + 1, q + 1);
            cout << "\n out_shuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":   " << z;
            z.unshuffle (false, p + 1, q + 1);
            cout << "\n out_unshuffle: ";
            show_pq (p + 1, q + 1);
            cout << ": " << z;

            cout << "\n\n start:                   " << z;
            z.shuffle (true, p + 1, q + 1);
            cout << "\n in_shuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":    " << z;
            z.unshuffle (true, p + 1, q + 1);
            cout << "\n in_unshuffle: ";
            show_pq (p + 1, q + 1);
            cout << ":  " << z;
        }
    #endif

    #if USE_ARR_0 && USE_ARR_1
        void canonical () {
            cout << "\n\n ----- demo_J_shuffle::canonical -----";

            constexpr int size {6};
            constexpr int sanity_check {20};

            {
                cout << "\n\n out_shuffle, zero-based: ";
                permu_arr_0<size> const orig (false);
                permu_arr_0<size> work {orig};
                cout << "\n " << setw (2) << 0 << ": " << work;
                int n {1};
                for ( ; n < sanity_check; ++n) {
                    work.shuffle (false, 0, 2);
                    cout << "\n " << setw (2) << n << ": " << work;
                    if (work == orig) break;
                }
                if (n >= sanity_check) throw fail
                    {"demo_J_shuffle::canonical ... overrun"};
            } {
                cout << "\n\n in_shuffle, zero-based: ";
                permu_arr_0<size> const orig (false);
                permu_arr_0<size> work {orig};
                cout << "\n " << setw (2) << 0 << ": " << work;
                int n {1};
                for ( ; n < sanity_check; ++n) {
                    work.shuffle (true, 1, 3);
                    cout << "\n " << setw (2) << n << ": " << work;
                    if (work == orig) break;
                }
                if (n >= sanity_check) throw fail
                    {"demo_J_shuffle::canonical ... overrun"};
            } {
                cout << "\n\n out_shuffle, one-based: ";
                permu_arr_1<size> const orig (false);
                permu_arr_1<size> work {orig};
                cout << "\n " << setw (2) << 1 << ": " << work;
                int n {2};
                for ( ; n < sanity_check; ++n) {
                    work.shuffle (false, 1, 3);
                    cout << "\n " << setw (2) << n << ": " << work;
                    if (work == orig) break;
                }
                if (n >= sanity_check) throw fail
                    {"demo_J_shuffle::canonical ... overrun"};
            } {
                cout << "\n\n in_shuffle, one-based: ";
                permu_arr_1<size> const orig (false);
                permu_arr_1<size> work {orig};
                cout << "\n " << setw (2) << 1 << ": " << work;
                int n {2};
                for ( ; n < sanity_check; ++n) {
                    work.shuffle (true, 2, 4);
                    cout << "\n " << setw (2) << n << ": " << work;
                    if (work == orig) break;
                }
                if (n >= sanity_check) throw fail
                    {"demo_J_shuffle::canonical ... overrun"};
            }
        }
    #endif
}