
namespace demo_L_cycles {
    template <typename permu>
    void view (permu const & p) {
        {
            cout << "\n ";
            cout << "\n p:    " << p;
            cout << "   inv:  " << p.inversion_count ();
            cout << "   sgn:  " << std::showpos << p.sign() << std::noshowpos;
            auto const c (p.get_cycles());
            cout << "\n c:    " << c;
            auto const a (c.rebuild ());
            cout << "\n a:    "; view_container (cout, a);
            permu const q (a);
            cout << "\n q:    " << q;
        } {
            auto const pi (p.invert ());
            cout << "\n ";
            cout << "\n pi:   " << pi;
            cout << "   inv:  " << pi.inversion_count ();
            cout << "   sgn:  " << std::showpos << pi.sign() << std::noshowpos;
            auto const ci (pi.get_cycles());
            cout << "\n ci:   " << ci;
            auto const ai (ci.rebuild ());
            cout << "\n ai:   "; view_container (cout, ai);
            permu const qi (ai);
            cout << "\n qi:   " << qi;
        }
    }

    #if USE_ARR_0
        void arr_0 () {
            static permu_arr_0<demo_ord> const i (false);
            cout << "\n\n ----- demo_L_cycles::arr_0 ----- ";
            cout << "\n\n pos:  " << i;
            view (demo_wa);
            cout << "\n\n pos:  " << i;
            view (demo_wb);
            cout << "\n\n pos:  " << i;
            view (demo_wc);
        }
    #endif

    #if USE_ARR_1
        void arr_1 () {
            static permu_arr_1<demo_ord> const i (false);
            cout << "\n\n ----- demo_L_cycles::arr_1 ----- ";
            cout << "\n\n pos:  " << i;
            view (demo_xa);
            cout << "\n\n pos:  " << i;
            view (demo_xb);
            cout << "\n\n pos:  " << i;
            view (demo_xc);
        }
    #endif

    #if USE_VEC_0
        void vec_0 () {
            static permu_vec_0 const i (demo_ord, false);
            cout << "\n\n ----- demo_L_cycles::vec_0 ----- ";
            cout << "\n\n pos:  " << i;
            view (demo_ya);
            cout << "\n\n pos:  " << i;
            view (demo_yb);
            cout << "\n\n pos:  " << i;
            view (demo_yc);
        }
    #endif

    #if USE_VEC_1
        void vec_1 () {
            static permu_vec_1 const i (demo_ord, false);
            cout << "\n\n ----- demo_L_cycles::vec_1 ----- ";
            cout << "\n\n pos:  " << i;
            view (demo_za);
            cout << "\n\n pos:  " << i;
            view (demo_zb);
            cout << "\n\n pos:  " << i;
            view (demo_zc);
        }
    #endif
}
