
namespace demo_R_distance {
    using namespace distance;
    using namespace statistics;

    double const p_bot {0.823413};
    double const p_inc {5.779058};
    double const p_top {35.0};

    #if USE_ARR_0
        void arr_0 () {
            cout << "\n\n ----- demo_R_distance::arr_0 ----- ";
            auto const & a (demo_wa);
            auto const & b (demo_wb);
            auto const & c (demo_wc);
            auto const d (a.get_cycles());
            auto const e (b.get_cycles());
            auto const f (c.get_cycles());

            cout << "\n ";
            cout << "\n a:  " << a << "   " << d << " " << d.qty ();
            cout << "\n b:  " << b << "   " << e << " " << e.qty ();
            cout << "\n c:  " << c << "   " << f << " " << f.qty ();

            cout << "\n\n cayley ....";
            cout <<   " ab: " << setw (3) << cayley (a, b);
            cout << "   bc: " << setw (3) << cayley (b, c);
            cout << "   ca: " << setw (3) << cayley (c, a);
            cout << "\n hamming ...";
            cout <<   " ab: " << setw (3) << hamming (a, b);
            cout << "   bc: " << setw (3) << hamming (b, c);
            cout << "   ca: " << setw (3) << hamming (c, a);
            cout << "\n maximum ...";
            cout <<   " ab: " << setw (3) << maximum (a, b);
            cout << "   bc: " << setw (3) << maximum (b, c);
            cout << "   ca: " << setw (3) << maximum (c, a);
            cout << "\n minimum ...";
            cout <<   " ab: " << setw (3) << minimum (a, b);
            cout << "   bc: " << setw (3) << minimum (b, c);
            cout << "   ca: " << setw (3) << minimum (c, a);

            cout << "\n ";
            for (double p {p_bot}; p <= p_top; p += p_inc) {
                cout << "\n minkowski " << setw (9) << p << " ...";
                cout <<   " ab: " << setw (10) << minkowski (a, b, p);
                cout << "   bc: " << setw (10) << minkowski (b, c, p);
                cout << "   ca: " << setw (10) << minkowski (c, a, p);
            }

            cout << "\n\n correlation ...";
            cout <<   " ab: " << setw (10) << correlation (a, b);
            cout << "   bc: " << setw (10) << correlation (b, c);
            cout << "   ca: " << setw (10) << correlation (c, a);
            cout << "\n covariance ....";
            cout <<   " ab: " << setw (10) << covariance (a, b);
            cout << "   bc: " << setw (10) << covariance (b, c);
            cout << "   ca: " << setw (10) << covariance (c, a);
        }
    #endif

    #if USE_ARR_1
        void arr_1 () {
            cout << "\n\n ----- demo_R_distance::arr_1 ----- ";
            auto const & a (demo_xa);
            auto const & b (demo_xb);
            auto const & c (demo_xc);
            auto const d (a.get_cycles());
            auto const e (b.get_cycles());
            auto const f (c.get_cycles());

            cout << "\n ";
            cout << "\n a:  " << a << "   " << d << " " << d.qty ();
            cout << "\n b:  " << b << "   " << e << " " << e.qty ();
            cout << "\n c:  " << c << "   " << f << " " << f.qty ();

            cout << "\n\n cayley ....";
            cout <<   " ab: " << setw (3) << cayley (a, b);
            cout << "   bc: " << setw (3) << cayley (b, c);
            cout << "   ca: " << setw (3) << cayley (c, a);
            cout << "\n hamming ...";
            cout <<   " ab: " << setw (3) << hamming (a, b);
            cout << "   bc: " << setw (3) << hamming (b, c);
            cout << "   ca: " << setw (3) << hamming (c, a);
            cout << "\n maximum ...";
            cout <<   " ab: " << setw (3) << maximum (a, b);
            cout << "   bc: " << setw (3) << maximum (b, c);
            cout << "   ca: " << setw (3) << maximum (c, a);
            cout << "\n minimum ...";
            cout <<   " ab: " << setw (3) << minimum (a, b);
            cout << "   bc: " << setw (3) << minimum (b, c);
            cout << "   ca: " << setw (3) << minimum (c, a);

            cout << "\n ";
            for (double p {p_bot}; p <= p_top; p += p_inc) {
                cout << "\n minkowski " << setw (9) << p << " ...";
                cout <<   " ab: " << setw (10) << minkowski (a, b, p);
                cout << "   bc: " << setw (10) << minkowski (b, c, p);
                cout << "   ca: " << setw (10) << minkowski (c, a, p);
            }

            cout << "\n\n correlation ...";
            cout <<   " ab: " << setw (10) << correlation (a, b);
            cout << "   bc: " << setw (10) << correlation (b, c);
            cout << "   ca: " << setw (10) << correlation (c, a);
            cout << "\n covariance ....";
            cout <<   " ab: " << setw (10) << covariance (a, b);
            cout << "   bc: " << setw (10) << covariance (b, c);
            cout << "   ca: " << setw (10) << covariance (c, a);
        }
    #endif

    #if USE_VEC_0
        void vec_0 () {
            cout << "\n\n ----- demo_R_distance::vec_0 ----- ";
            auto const & a (demo_ya);
            auto const & b (demo_yb);
            auto const & c (demo_yc);
            auto const d (a.get_cycles());
            auto const e (b.get_cycles());
            auto const f (c.get_cycles());

            cout << "\n ";
            cout << "\n a:  " << a << "   " << d << " " << d.qty ();
            cout << "\n b:  " << b << "   " << e << " " << e.qty ();
            cout << "\n c:  " << c << "   " << f << " " << f.qty ();

            cout << "\n\n cayley ....";
            cout <<   " ab: " << setw (3) << cayley (a, b);
            cout << "   bc: " << setw (3) << cayley (b, c);
            cout << "   ca: " << setw (3) << cayley (c, a);
            cout << "\n hamming ...";
            cout <<   " ab: " << setw (3) << hamming (a, b);
            cout << "   bc: " << setw (3) << hamming (b, c);
            cout << "   ca: " << setw (3) << hamming (c, a);
            cout << "\n maximum ...";
            cout <<   " ab: " << setw (3) << maximum (a, b);
            cout << "   bc: " << setw (3) << maximum (b, c);
            cout << "   ca: " << setw (3) << maximum (c, a);
            cout << "\n minimum ...";
            cout <<   " ab: " << setw (3) << minimum (a, b);
            cout << "   bc: " << setw (3) << minimum (b, c);
            cout << "   ca: " << setw (3) << minimum (c, a);

            cout << "\n ";
            for (double p {p_bot}; p <= p_top; p += p_inc) {
                cout << "\n minkowski " << setw (9) << p << " ...";
                cout <<   " ab: " << setw (10) << minkowski (a, b, p);
                cout << "   bc: " << setw (10) << minkowski (b, c, p);
                cout << "   ca: " << setw (10) << minkowski (c, a, p);
            }

            cout << "\n\n correlation ...";
            cout <<   " ab: " << setw (10) << correlation (a, b);
            cout << "   bc: " << setw (10) << correlation (b, c);
            cout << "   ca: " << setw (10) << correlation (c, a);
            cout << "\n covariance ....";
            cout <<   " ab: " << setw (10) << covariance (a, b);
            cout << "   bc: " << setw (10) << covariance (b, c);
            cout << "   ca: " << setw (10) << covariance (c, a);
        }
    #endif

    #if USE_VEC_1
        void vec_1 () {
            cout << "\n\n ----- demo_R_distance::vec_1 ----- ";
            auto const & a (demo_za);
            auto const & b (demo_zb);
            auto const & c (demo_zc);
            auto const d (a.get_cycles());
            auto const e (b.get_cycles());
            auto const f (c.get_cycles());

            cout << "\n ";
            cout << "\n a:  " << a << "   " << d << " " << d.qty ();
            cout << "\n b:  " << b << "   " << e << " " << e.qty ();
            cout << "\n c:  " << c << "   " << f << " " << f.qty ();

            cout << "\n\n cayley ....";
            cout <<   " ab: " << setw (3) << cayley (a, b);
            cout << "   bc: " << setw (3) << cayley (b, c);
            cout << "   ca: " << setw (3) << cayley (c, a);
            cout << "\n hamming ...";
            cout <<   " ab: " << setw (3) << hamming (a, b);
            cout << "   bc: " << setw (3) << hamming (b, c);
            cout << "   ca: " << setw (3) << hamming (c, a);
            cout << "\n maximum ...";
            cout <<   " ab: " << setw (3) << maximum (a, b);
            cout << "   bc: " << setw (3) << maximum (b, c);
            cout << "   ca: " << setw (3) << maximum (c, a);
            cout << "\n minimum ...";
            cout <<   " ab: " << setw (3) << minimum (a, b);
            cout << "   bc: " << setw (3) << minimum (b, c);
            cout << "   ca: " << setw (3) << minimum (c, a);

            cout << "\n ";
            for (double p {p_bot}; p <= p_top; p += p_inc) {
                cout << "\n minkowski " << setw (9) << p << " ...";
                cout <<   " ab: " << setw (10) << minkowski (a, b, p);
                cout << "   bc: " << setw (10) << minkowski (b, c, p);
                cout << "   ca: " << setw (10) << minkowski (c, a, p);
            }

            cout << "\n\n correlation ...";
            cout <<   " ab: " << setw (10) << correlation (a, b);
            cout << "   bc: " << setw (10) << correlation (b, c);
            cout << "   ca: " << setw (10) << correlation (c, a);
            cout << "\n covariance ....";
            cout <<   " ab: " << setw (10) << covariance (a, b);
            cout << "   bc: " << setw (10) << covariance (b, c);
            cout << "   ca: " << setw (10) << covariance (c, a);
        }
    #endif
}