
namespace patterns {
    template <typename permu>
    bool contains_231 (permu const & p) {
        int const s {int (p.size())};
        for (int a {  0  }; a < s; ++a) {
            int const p2 {p.at(a)};
        for (int b {a + 1}; b < s; ++b) {
            int const p3 {p.at(b)};
            if (p3 <  p2) continue;
        for (int c {b + 1}; c < s; ++c) {
            int const p1 {p.at(c)};
            if (p1 >  p2) continue;
            if (p1 >  p3) continue;
        return true;
        } } }
        return false;
    }

    template <typename permu>
    bool contains_2413 (permu const & p) {
        int const s {int (p.size())};
        for (int a {  0  }; a < s; ++a) {
            int const p2 {p.at(a)};
        for (int b {a + 1}; b < s; ++b) {
            int const p4 {p.at(b)};
            if (p4 <  p2) continue;
        for (int c {b + 1}; c < s; ++c) {
            int const p1 {p.at(c)};
            if (p1 >  p2) continue;
            if (p1 >  p4) continue;
        for (int d {c + 1}; d < s; ++d) {
            int const p3 {p.at(d)};
            if (p3 <  p2) continue;
            if (p3 >  p4) continue;
            if (p3 <  p1) continue;
        return true;
        } } } }
        return false;
    }

    template <typename permu>
    bool contains_3142 (permu const & p) {
        int const s {int (p.size())};
        for (int a {  0  }; a < s; ++a) {
            int const p3 {p.at(a)};
        for (int b {a + 1}; b < s; ++b) {
            int const p1 {p.at(b)};
            if (p1 >  p3) continue;
        for (int c {b + 1}; c < s; ++c) {
            int const p4 {p.at(c)};
            if (p4 <  p3) continue;
            if (p4 <  p1) continue;
        for (int d {c + 1}; d < s; ++d) {
            int const p2 {p.at(d)};
            if (p2 >  p3) continue;
            if (p2 <  p1) continue;
            if (p2 >  p4) continue;
        return true;
        } } } }
        return false;
    }

    template <typename permu>
    bool stack_sortable (permu const & v) {
        if (contains_231 (v)) return false;
        return true;
    }

    template <typename permu>
    bool separable (permu const & v) {
        if (contains_2413 (v)) return false;
        if (contains_3142 (v)) return false;
        return true;
    }
}

///////////

namespace shuffle {
    template <typename permu>
    void install (permu & p, bool const out_in, int & loc, int val) {
        int const s {int (p.size())};
        if (permu_safe) {
            if (loc <  0) throw fail {"shuffle::install ... loc <  0"};
            if (loc >= s) throw fail {"shuffle::install ... loc >= s"};
        }
        for (int i {0}; i < s; ++i) {
            int & curr {p.at (loc)};
            if (curr == -1) {
                curr = val;
                return;
            }

            if (out_in) {
                --loc;
                if (loc < 0) loc = s - 1;
            } else {
                ++loc;
                if (loc >= s) loc -= s;
            }
        }
        throw fail {"shuffle::install ... no empty spots"};
    }

    template <typename permu>
    void extract (permu & p, bool const out_in, int & loc, int & val) {
        int const s {int (p.size())};
        if (permu_safe) {
            if (loc <  0) throw fail {"shuffle::extract ... loc <  0"};
            if (loc >= s) throw fail {"shuffle::extract ... loc >= s"};
        }
        for (int i {0}; i < s; ++i) {
            int & curr {p.at (loc)};
            if (curr != -1) {
                val = curr;
                curr = -1;
                return;
            }

            if (out_in) {
                --loc;
                if (loc < 0) loc = s - 1;
            } else {
                ++loc;
                if (loc >= s) loc -= s;
            }
        }
        throw fail {"shuffle::extract ... could not find"};
    }

    template <typename permu>
    void fore (permu & p, bool const out_in, int const a, int const b) {
        int const s {int (p.size())};
        permu temp {p};
        std::fill (temp.begin(), temp.end(), -1);
        int const gap {(s + b - a) % s};
        int loc {a};
        for (int i {0}; i < s; ++i) {
            install (temp, out_in, loc, p.at(i));
            loc += gap;
            if (loc >= s) loc -= s;
        }
        std::swap (temp, p);
    }

    template <typename permu>
    void back (permu & p, bool const out_in, int const a, int const b) {
        int const s {int (p.size())};
        permu temp {p};
        std::fill (temp.begin(), temp.end(), -1);
        int const gap {(s + b - a) % s};
        int loc {a};
        for (int i {0}; i < s; ++i) {
            extract (p, out_in, loc, temp.at(i));
            loc += gap;
            if (loc >= s) loc -= s;
        }
        std::swap (temp, p);
    }
}

///////////

namespace value {
    template <typename iter>
    void reverse (iter begin, iter end, int const lo, int const hi) {
        // hi is one beyond
        if ( lo      == hi) return; // zero elements affected
        if ((lo + 1) == hi) return; // one element affected

        int const mirror {lo + hi - 1};

        for (auto i (begin); i != end; ++i) {
            if (*i <  lo) continue;
            if (*i >= hi) continue;
            *i = mirror - *i;
        }
    }

    template <typename iter>
    void transpose (
        iter begin, iter end,
        int const i, int const j, int const k
    ) {
        if (k == 0) return; // zero elements affected

        for (int l {0}; l < k; ++l) {
            auto p (std::find (begin, end, i + l));
            auto q (std::find (begin, end, j + l));
            std::swap (*p, *q);
        }
    }

    template <typename iter>
    void rotate (
        iter begin, iter end,
        int const lo, int const md, int const hi
    ) {
        int dist {md - lo};

        for (auto i (begin); i != end; ++i) {
            if (*i <  lo) continue;
            if (*i >= hi) continue;
            *i += dist;
            if (*i < lo)
                *i += (hi - lo);
            else if (*i >= hi)
                *i -= (hi - lo);
        }
    }
}

