
#if USE_ARR_0 && USE_ARR_1
    template <int sz>
    permu_arr_0<sz>::permu_arr_0 (permu_arr_1<sz> const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) --n;
        verify_guts ();
    }

    template <int sz>
    permu_arr_1<sz>::permu_arr_1 (permu_arr_0<sz> const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) ++n;
        verify_guts ();
    }

    template <int sz>
    cycles_arr_0<sz>::cycles_arr_0 (cycles_arr_1<sz> const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) if (n >= o.base) --n;
    }

    template <int sz>
    cycles_arr_1<sz>::cycles_arr_1 (cycles_arr_0<sz> const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) if (n >= o.base) ++n;
    }
#endif

#if USE_VEC_0 && USE_VEC_1
    permu_vec_0::permu_vec_0 (permu_vec_1 const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) --n;
        verify_guts ();
    }

    permu_vec_1::permu_vec_1 (permu_vec_0 const & o) :
        guts {o.at()}
    {
        for (auto & n: guts) ++n;
        verify_guts ();
    }

    cycles_vec_0::cycles_vec_0 (cycles_vec_1 const & o) :
        sz {o.size()}, guts {o.at()}
    {
        for (auto & n: guts) if (n >= o.base) --n;
    }

    cycles_vec_1::cycles_vec_1 (cycles_vec_0 const & o) :
        sz {o.size()}, guts {o.at()}
    {
        for (auto & n: guts) if (n >= o.base) ++n;
    }
#endif

#if USE_VEC_0 && USE_ARR_0
    template <int sz>
    permu_vec_0::permu_vec_0 (permu_arr_0<sz> const & o) {
        auto const & a (o.at());
        std::copy (a.cbegin(), a.cend(), std::back_inserter (guts));
        verify_guts ();
    }

    template <int sz>
    permu_arr_0<sz>::permu_arr_0 (permu_vec_0 const & o) {
        auto const & v (o.at());
        std::copy (v.cbegin(), v.cend(), guts.begin());
        verify_guts ();
    }

    template <int tz>
    cycles_vec_0::cycles_vec_0 (cycles_arr_0<tz> const & o) :
        sz {tz}
    {
        auto const & a (o.at());
        for (int i {0}; i < a.size(); ++i) {
            int const b {a.at (i)};
            if (b == filler) break;
            guts.push_back(b);
        }
    }

    template <int sz>
    cycles_arr_0<sz>::cycles_arr_0 (cycles_vec_0 const & o) {
//        cout << "\n this one";
        if (o.size() != sz) throw fail
            {"cycles_arr_0::cycles_arr_0 (cycles_vec_0) ... size mismatch"};
        auto const & v (o.at());
        int i {0};
        for ( ; i < v.size(); ++i)
            guts.at(i) = v.at(i);
        for ( ; i < guts.size(); ++i)
            guts.at(i) = filler;
    }
#endif

#if USE_VEC_1 && USE_ARR_1
    template <int sz>
    permu_vec_1::permu_vec_1 (permu_arr_1<sz> const & o) {
        auto const & a (o.at());
        std::copy (a.cbegin(), a.cend(), std::back_inserter (guts));
        verify_guts ();
    }

    template <int sz>
    permu_arr_1<sz>::permu_arr_1 (permu_vec_1 const & o) {
        auto const & v (o.at());
        std::copy (v.cbegin(), v.cend(), guts.begin());
        verify_guts ();
    }

    template <int tz>
    cycles_vec_1::cycles_vec_1 (cycles_arr_1<tz> const & o) :
        sz {tz}
    {
        auto const & a (o.at());
        for (int i {0}; i < a.size(); ++i) {
            int const b {a.at (i)};
            if (b == filler) break;
            guts.push_back(b);
        }
    }

    template <int sz>
    cycles_arr_1<sz>::cycles_arr_1 (cycles_vec_1 const & o) {
//        cout << "\n this two";
        if (o.size() != sz) throw fail
            {"cycles_arr_1::cycles_arr_1 (cycles_vec_1) ... size mismatch"};
        auto const & v (o.at());
        int i {0};
        for ( ; i < v.size(); ++i)
            guts.at(i) = v.at(i);
        for ( ; i < guts.size(); ++i)
            guts.at(i) = filler;
    }
#endif
